import java.util.HashMap;
import java.util.Queue;
import java.util.TimerTask;

import javax.swing.SwingUtilities;

import edu.umd.cs.piccolo.PNode;
/**
 * Doing Stepwise animation
 * Using the Timertask class, 
 * calling the animationStep routine for each node.
 * To be threadsafe invokeLater is used
 *
 */
public class AnimationTask extends TimerTask {

	private HashMap<GraphNode, PNode> nodes = null;

	public AnimationTask(HashMap<GraphNode, PNode> nodes,
			RadialGraphBuilder graphBuilder) {
		this.nodes = nodes;
		this.graphBuilder = graphBuilder;
	}

	RadialGraphBuilder graphBuilder = null;
/**
 * working method for animation.
 */
	@Override
	public void run() {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				boolean animationRunning = false;
				graphBuilder.animationRunning = true;
				
				for (GraphNode node : nodes.keySet()) {
					if (node.animationStep()) {
						animationRunning = true;
					}
				}

				if (animationRunning == true) {
					graphBuilder.updateNodes();
				} else {
					graphBuilder.animationRunning = false;
					AnimationTask.this.cancel();
				}
			}
		});

	}
}
